'use strict';

$(function () {
    $.extend({
        gAjax: function gAjax(o) {
            if ((typeof o === 'undefined' ? 'undefined' : _typeof(o)) === 'object') {
                var c = $.extend(true, {}, o);
                $.mdsort(c.data);
                if (c.success) {
                    c.success = function (data) {
                        o.success(data);
                    };
                }
                $.ajax(c);
            }
        },
        mdsort: function mdsort(data) {
            var key = [];
            var newData = [];
            var timestamp = Math.round(new Date().getTime() / 1000);
            var paramsUrl = '';
            data.timestamp = timestamp;
            for (var k in data) {
                key.push(k);
            }
            key.sort();
            for (var i in key) {
                var name = key[i];
                var value = encodeURIComponent(data[key[i]]);
                paramsUrl += name + '=' + value + '&';
            }
            paramsUrl = paramsUrl.substr(0, paramsUrl.length - 1);
            data.md5 = $.md5(paramsUrl);
            return data;
        },
        jsonToUrl: function jsonToUrl(param) {
            var paramsUrl = '';
            for (var i in param) {
                var name = param[i];
                var value = encodeURIComponent(param[i]);
                paramsUrl += name + '=' + value + '&';
            }
            paramsUrl = paramsUrl.substr(0, paramsUrl.length - 1);
            return paramsUrl;
        },
        formatTime: function formatTime(stringTime) {
            //safari内核有时间需要转成 2017/1/4 11:55:52格式
            stringTime = stringTime.replace(/-/g, '/');
            var timestamp = Date.parse(new Date(stringTime));
            timestamp = timestamp / 1000;
            return timestamp;
        },
        arrToJson: function arrToJson(arr) {
            var data = {};
            for (var k in arr) {
                data[arr[k].name] = arr[k].value;
            }
            return data;
        },
        getUrlParam: function getUrlParam(name) {
            var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
            var reg_p = new RegExp("(^|/)" + name + "/([^/]*)(/|$)");
            var r = window.location.search.substr(1).match(reg);
            if (r != null) {
                return unescape(r[2]);
            } else {
                var i = '';
                var rp = window.location.pathname.match(reg_p);
                if (rp != null) {
                    i = rp[2].replace('.html', '');
                }
                return i;
            }
        },
        unParam: function unParam(url) {
            var obj = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            var reg_url = /^[^\?]+\?([\w\W]+)$/,
                reg_para = /([^&=]+)=([\w\W]*?)(&|$|#)/g,
                arr_url = reg_url.exec(decodeURIComponent(url)),
                ret = {};
            if (arr_url && arr_url[1]) {
                var str_para = arr_url[1],
                    result,
                    i = 0;
                while ((result = reg_para.exec(str_para)) != null) {
                    if (obj == false) {
                        ret[result[1]] = result[2];
                    } else {
                        ret[i] = { name: result[1], value: result[2] };
                    }
                    i++;
                }
            }
            return ret;
        },
        getUA: function getUA() {
            var u = navigator.userAgent;
            var u2 = navigator.userAgent.toLowerCase();
            return { //移动终端浏览器版本信息
                trident: u.indexOf('Trident') > -1, //IE内核
                presto: u.indexOf('Presto') > -1, //opera内核
                webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
                gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1, //火狐内核
                mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
                ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
                android: u.indexOf('Android') > -1 || u.indexOf('Linux') > -1, //android终端或uc浏览器
                iPhone: u.indexOf('iPhone') > -1, //是否为iPhone或者QQHD浏览器
                iPad: u.indexOf('iPad') > -1, //是否iPad
                webApp: u.indexOf('Safari') == -1, //是否web应该程序，没有头部与底部
                iosv: u.substr(u.indexOf('iPhone OS') + 9, 3),
                weixin: u2.match(/MicroMessenger/i) == "micromessenger",
                ali: u.indexOf('AliApp') > -1,
                specialIphone: u.indexOf('QQ/6.5') > -1 && u.indexOf('OS 10_3_1') > -1
            };
        },
    });
});
